PredictSat.Web/Controllers/PredictionController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using PredictSat.Services.Predictions;
using PredictSat.Core.Domain.Predictions;
using IdentitySample.Models;
using Microsoft.AspNet.Identity;
using PredictSat.Web.ViewModels;
using PredictSat.Web.Adapters;

namespace PredictSat.Web.Controllers
{
    [Authorize]
    public class PredictionController : Controller
    {
        private ISatPredictionService _predictionService;

        public PredictionController(ISatPredictionService predictionService)
        {
            _predictionService = predictionService;
        }



        //
        // GET: /Prediction/
        
        public ActionResult Index()
        {
            string userId = User.Identity.GetUserId();

            var predictions = _predictionService.GetAllPrections(userId);

            return View(predictions);
        }


        //
        // GET: /Prediction/Create
        [HttpGet]
        public ActionResult Create(PredictionCompleteViewModel model)
        {
            return View(model);
        }

        //
        // POST: /Prediction/Create
        [HttpPost]
        public ActionResult Save(PredictionCompleteViewModel model)
        {
            if (!ModelState.IsValid)
                return RedirectToAction("Create", model);


            try
            {
                model.UserId = User.Identity.GetUserId();
                // TODO: Add insert logic here
                _predictionService.InsertPrediction(PredictionCompleteViewModelAdapter.FromViewModel(model));

                return RedirectToAction("Index");
            }
            catch
            {
                return View("Error");
            }
        }


        public ActionResult MakePrediction()
        {
            return View();
        }

        [HttpPost]
        public ActionResult MakePrediction(SatPredictionInput prediction)
        {
            if (!ModelState.IsValid)
                return View(prediction);

            try
            {
                // TODO: Add insert logic here
                var predictionResult = _predictionService.MakePrediction(prediction);

                var predictionComplete = PredictionCompleteViewModelAdapter.ToViewModel(prediction, predictionResult);

                return RedirectToAction("Create", predictionComplete);
            }
            catch
            {
                return View("Error");
            }

        }

        //
        // GET: /Prediction/Edit/5
        public ActionResult Edit(int id)
        {
            return View();
        }

        //
        // POST: /Prediction/Edit/5
        [HttpPost]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        
        public ActionResult Details(int id)
        {
            var prediction = _predictionService.GetPredictionInputAndResultById(id);

            var viewModel = PredictionCompleteViewModelAdapter.ToViewModel(prediction);

            return View(viewModel);
        }

        //
        // GET: /Prediction/Delete/5
        public ActionResult Delete(int id)
        {
            var prediction = _predictionService.GetPredictionInputAndResultById(id);

            var viewModel = PredictionCompleteViewModelAdapter.ToViewModel(prediction);

            return View(viewModel);
        }

        //
        // POST: /Prediction/Delete/5
        [HttpPost]
        public ActionResult Remove(int id)
        {
            
            //try
            //{
                // TODO: Add delete logic here
                _predictionService.DeletePredictionById(id);

                return RedirectToAction("Index");
            //}
            //catch
            //{
            //    return View("Error");
            //}
        }
    }
}

PredictSat.Web/Views/Prediction/Create.cshtml
@model PredictSat.Web.ViewModels.PredictionCompleteViewModel

@{
    ViewBag.Title = "Create";
}
  

<h2>Current Prediction</h2>


@using (Html.BeginForm("Save", "Prediction", FormMethod.Post, new { @class = "form-horizontal", role = "form", id = "predictionForm" })) 
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">

        @Html.ValidationSummary("", new { @class = "text-danger" })

        <h4>Prediction Result:</h4>

        <div class="form-group">
            @Html.LabelFor(model => model.CriticalReadingMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.CriticalReadingMean)
                @Html.ValidationMessageFor(model => model.CriticalReadingMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.WritingMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.WritingMean)
                @Html.ValidationMessageFor(model => model.WritingMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.MathematicsMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.MathematicsMean)
                @Html.ValidationMessageFor(model => model.MathematicsMean)
            </div>
        </div>

        <hr />

        <h4>Chosen Inputs:</h4>
        
        @Html.HiddenFor(t => t.UserId, new { value = "-NONE-" })

        <div class="form-group">
            @Html.LabelFor(model => model.SchoolName, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SchoolName)
                @Html.ValidationMessageFor(model => model.SchoolName)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ForYear, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ForYear)
                @Html.ValidationMessageFor(model => model.ForYear)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.NumberTestTakers, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.NumberTestTakers)
                @Html.ValidationMessageFor(model => model.NumberTestTakers)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PeerIndex, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PeerIndex)
                @Html.ValidationMessageFor(model => model.PeerIndex)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PerformanceCategoryScore, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PerformanceCategoryScore)
                @Html.ValidationMessageFor(model => model.PerformanceCategoryScore)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.NumberOfClassesMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.NumberOfClassesMean)
                @Html.ValidationMessageFor(model => model.NumberOfClassesMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.SchoolWideTeacherPupilRation, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SchoolWideTeacherPupilRation)
                @Html.ValidationMessageFor(model => model.SchoolWideTeacherPupilRation)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.AvgClassSizeMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.AvgClassSizeMean)
                @Html.ValidationMessageFor(model => model.AvgClassSizeMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ProgressCategoryScore, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ProgressCategoryScore)
                @Html.ValidationMessageFor(model => model.ProgressCategoryScore)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.SizeOfSmallestClass, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SizeOfSmallestClass)
                @Html.ValidationMessageFor(model => model.SizeOfSmallestClass)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.TotalRegisterMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.TotalRegisterMean)
                @Html.ValidationMessageFor(model => model.TotalRegisterMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.EnviromentCategoryScore, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.EnviromentCategoryScore)
                @Html.ValidationMessageFor(model => model.EnviromentCategoryScore)
            </div>
        </div>


        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    
    <script type="text/javascript">

       

    </script>
}

PredictSat.Web/Views/Prediction/Delete.cshtml
@model PredictSat.Web.ViewModels.PredictionCompleteViewModel

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>PredictionCompleteViewModel</h4>
    <hr />
    <dl class="dl-horizontal">

        <dt>
            @Html.DisplayNameFor(model => model.SchoolName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SchoolName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ForYear)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ForYear)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NumberTestTakers)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NumberTestTakers)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PeerIndex)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PeerIndex)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PerformanceCategoryScore)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PerformanceCategoryScore)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NumberOfClassesMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NumberOfClassesMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.SchoolWideTeacherPupilRation)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SchoolWideTeacherPupilRation)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.AvgClassSizeMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.AvgClassSizeMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ProgressCategoryScore)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProgressCategoryScore)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.SizeOfSmallestClass)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SizeOfSmallestClass)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.TotalRegisterMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.TotalRegisterMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.EnviromentCategoryScore)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.EnviromentCategoryScore)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.CriticalReadingMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CriticalReadingMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.MathematicsMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.MathematicsMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.WritingMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.WritingMean)
        </dd>

    </dl>

    @using (Html.BeginForm(Html.BeginForm("Remove", "Prediction", new { id = Model.Id }, FormMethod.Post, new { @class = "form-horizontal", role = "form" })))
    {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Back to List", "Index")
        </div>
    }
</div>

PredictSat.Web/Views/Prediction/Details.cshtml
@model PredictSat.Web.ViewModels.PredictionCompleteViewModel

@{
    ViewBag.Title = "Details";
}

<h2>Prediction Details</h2>

<div>

	<hr />
    <dl class="dl-horizontal">

        <dt>
            @Html.DisplayNameFor(model => model.SchoolName)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SchoolName)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ForYear)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ForYear)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NumberTestTakers)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NumberTestTakers)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PeerIndex)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PeerIndex)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.PerformanceCategoryScore)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.PerformanceCategoryScore)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NumberOfClassesMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NumberOfClassesMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.SchoolWideTeacherPupilRation)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SchoolWideTeacherPupilRation)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.AvgClassSizeMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.AvgClassSizeMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.ProgressCategoryScore)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.ProgressCategoryScore)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.SizeOfSmallestClass)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SizeOfSmallestClass)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.TotalRegisterMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.TotalRegisterMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.EnviromentCategoryScore)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.EnviromentCategoryScore)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.CriticalReadingMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.CriticalReadingMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.MathematicsMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.MathematicsMean)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.WritingMean)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.WritingMean)
        </dd>

    </dl>
</div>
<p>
    @Html.ActionLink("Back to List", "Index")
</p>

PredictSat.Web/Views/Prediction/Index.cshtml
@model IEnumerable<PredictSat.Core.Domain.Predictions.SatPredictionInput>

@{
    ViewBag.Title = "Index";
}

<h2>Index</h2>

<p>
    @Html.ActionLink("New Prediction", "MakePrediction")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.SchoolName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.ForYear)
        </th>
        <th>@Html.DisplayNameFor(model => model.PredictionResult.CriticalReadingMean)</th>
        <th>@Html.DisplayNameFor(model => model.PredictionResult.WritingMean)</th>
        <th>@Html.DisplayNameFor(model => model.PredictionResult.MathematicsMean)</th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.SchoolName)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.ForYear)
        </td>
        <th>@Html.DisplayFor(modelItem => item.PredictionResult.CriticalReadingMean)</th>
        <th>@Html.DisplayFor(modelItem => item.PredictionResult.WritingMean)</th>
        <th>@Html.DisplayFor(modelItem => item.PredictionResult.MathematicsMean)</th>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.Id }) |
            @Html.ActionLink("Details", "Details", new { id=item.Id }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.Id })
        </td>
    </tr>
}

</table>

PredictSat.Web/Views/Prediction/MakePrediction.cshtml
@model PredictSat.Core.Domain.Predictions.SatPredictionInput

@{
    ViewBag.Title = "Make Prediction";
}


<h2>Make Prediction</h2>


@using (Html.BeginForm("MakePrediction", "Prediction", FormMethod.Post, new { @class = "form-horizontal", role = "form", id = "predictionForm" }))
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>High School Data Inputs</h4>
        <hr />
        @Html.ValidationSummary("", new { @class = "text-danger" })

        @Html.HiddenFor(t => t.UserId, new { value = "a-b-c" })

        <div class="form-group">
            @Html.LabelFor(model => model.SchoolName, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SchoolName)
                @Html.ValidationMessageFor(model => model.SchoolName)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ForYear, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ForYear)
                @Html.ValidationMessageFor(model => model.ForYear)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.NumberTestTakers, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.NumberTestTakers)
                @Html.ValidationMessageFor(model => model.NumberTestTakers)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PeerIndex, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PeerIndex)
                @Html.ValidationMessageFor(model => model.PeerIndex)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.PerformanceCategoryScore, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.PerformanceCategoryScore)
                @Html.ValidationMessageFor(model => model.PerformanceCategoryScore)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.NumberOfClassesMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.NumberOfClassesMean)
                @Html.ValidationMessageFor(model => model.NumberOfClassesMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.SchoolWideTeacherPupilRation, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SchoolWideTeacherPupilRation)
                @Html.ValidationMessageFor(model => model.SchoolWideTeacherPupilRation)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.AvgClassSizeMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.AvgClassSizeMean)
                @Html.ValidationMessageFor(model => model.AvgClassSizeMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.ProgressCategoryScore, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.ProgressCategoryScore)
                @Html.ValidationMessageFor(model => model.ProgressCategoryScore)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.SizeOfSmallestClass, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SizeOfSmallestClass)
                @Html.ValidationMessageFor(model => model.SizeOfSmallestClass)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.TotalRegisterMean, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.TotalRegisterMean)
                @Html.ValidationMessageFor(model => model.TotalRegisterMean)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.EnviromentCategoryScore, new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.EnviromentCategoryScore)
                @Html.ValidationMessageFor(model => model.EnviromentCategoryScore)
            </div>
        </div>


        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit"  value="Make Prediction" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")

    <script type="text/javascript">

       

    </script>
}